/* IA64 register code and data definitions for HP-UX IA64.

   This is not a proper include file.  It should only be included by one
   file because it defines stuff.

   Copyright 1986 - 2000
   Free Software Foundation, Inc.

   This file is part of GDB.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* This file is separated out so that it can be used in both gdbserver
   and ia64-tdep.c.
   */

#include <ia64/sys/uregs.h>

/* The array map_gdb_reg_to_ureg is indexed by a gdb register number.
   The array entry contains the corresponding __uregs_t enum, or -1
   if there is no simple mapping.
   */

int map_gdb_reg_to_ureg [] =
	{ -1,		/* 0	FR0_REGNUM */
	  -1,		/* 1	FR1 */
	  __f2,		
	  __f3,
	  __f4,
	  __f5,
	  __f6,
	  __f7,
	  __f8,
	  __f9,
	  __f10,
	  __f11,
	  __f12,
	  __f13,
	  __f14,
	  __f15,
	  __f16,
	  __f17,
	  __f18,
	  __f19,
	  __f20,
	  __f21,
	  __f22,
	  __f23,
	  __f24,
	  __f25,
	  __f26,
	  __f27,
	  __f28,
	  __f29,
	  __f30,
	  __f31,
	  __f32,
	  __f33,
	  __f34,
	  __f35,
	  __f36,
	  __f37,
	  __f38,
	  __f39,
	  __f40,
	  __f41,
	  __f42,
	  __f43,
	  __f44,
	  __f45,
	  __f46,
	  __f47,
	  __f48,
	  __f49,
	  __f50,
	  __f51,
	  __f52,
	  __f53,
	  __f54,
	  __f55,
	  __f56,
	  __f57,
	  __f58,
	  __f59,
	  __f60,
	  __f61,
	  __f62,
	  __f63,
	  __f64,
	  __f65,
	  __f66,
	  __f67,
	  __f68,
	  __f69,
	  __f70,
	  __f71,
	  __f72,
	  __f73,
	  __f74,
	  __f75,
	  __f76,
	  __f77,
	  __f78,
	  __f79,
	  __f80,
	  __f81,
	  __f82,
	  __f83,
	  __f84,
	  __f85,
	  __f86,
	  __f87,
	  __f88,
	  __f89,
	  __f90,
	  __f91,
	  __f92,
	  __f93,
	  __f94,
	  __f95,
	  __f96,
	  __f97,
	  __f98,
	  __f99,
	  __f100,
	  __f101,
	  __f102,		
	  __f103,
	  __f104,
	  __f105,
	  __f106,
	  __f107,
	  __f108,
	  __f109,
	  __f110,
	  __f111,
	  __f112,
	  __f113,
	  __f114,
	  __f115,
	  __f116,
	  __f117,
	  __f118,
	  __f119,
	  __f120,
	  __f121,
	  __f122,
	  __f123,
	  __f124,
	  __f125,
	  __f126,
	  __f127,	/* 127	FRLAST_REGNUM */

	  -1,		/* 128	NR0_REGNUM */
	  -1,		/* 129	*/
	  -1,		/* 130	*/
	  -1,		/* 131	*/
	  -1,		/* 132	*/
	  -1,		/* 133	*/
	  -1,		/* 134	*/
	  -1,		/* 135	*/
	  -1,		/* 136	*/
	  -1,		/* 137	*/
	  -1,		/* 138	*/
	  -1,		/* 139	*/
	  -1,		/* 140	*/
	  -1,		/* 141	*/
	  -1,		/* 142	*/
	  -1,		/* 143	*/
	  -1,		/* 144	*/
	  -1,		/* 145	*/
	  -1,		/* 146	*/
	  -1,		/* 147	*/
	  -1,		/* 148	*/
	  -1,		/* 149	*/
	  -1,		/* 150	*/
	  -1,		/* 151	*/
	  -1,		/* 152	*/
	  -1,		/* 153	*/
	  -1,		/* 154	*/
	  -1,		/* 155	*/
	  -1,		/* 156	*/
	  -1,		/* 157	*/
	  -1,		/* 158	*/
	  -1,		/* 159	*/
	  -1,		/* 160	*/
	  -1,		/* 161	*/
	  -1,		/* 162	*/
	  -1,		/* 163	*/
	  -1,		/* 164	*/
	  -1,		/* 165	*/
	  -1,		/* 166	*/
	  -1,		/* 167	*/
	  -1,		/* 168	*/
	  -1,		/* 169	*/
	  -1,		/* 170	*/
	  -1,		/* 171	*/
	  -1,		/* 172	*/
	  -1,		/* 173	*/
	  -1,		/* 174	*/
	  -1,		/* 175	*/
	  -1,		/* 176	*/
	  -1,		/* 177	*/
	  -1,		/* 178	*/
	  -1,		/* 179	*/
	  -1,		/* 180	*/
	  -1,		/* 181	*/
	  -1,		/* 182	*/
	  -1,		/* 183	*/
	  -1,		/* 184	*/
	  -1,		/* 185	*/
	  -1,		/* 186	*/
	  -1,		/* 187	*/
	  -1,		/* 188	*/
	  -1,		/* 189	*/
	  -1,		/* 190	*/
	  -1,		/* 191	*/
	  -1,		/* 192	*/
	  -1,		/* 193	*/
	  -1,		/* 194	*/
	  -1,		/* 195	*/
	  -1,		/* 196	*/
	  -1,		/* 197	*/
	  -1,		/* 198	*/
	  -1,		/* 199	*/
	  -1,		/* 200	*/
	  -1,		/* 201	*/
	  -1,		/* 202	*/
	  -1,		/* 203	*/
	  -1,		/* 204	*/
	  -1,		/* 205	*/
	  -1,		/* 206	*/
	  -1,		/* 207	*/
	  -1,		/* 208	*/
	  -1,		/* 209	*/
	  -1,		/* 210	*/
	  -1,		/* 211	*/
	  -1,		/* 212	*/
	  -1,		/* 213	*/
	  -1,		/* 214	*/
	  -1,		/* 215	*/
	  -1,		/* 216	*/
	  -1,		/* 217	*/
	  -1,		/* 218	*/
	  -1,		/* 219	*/
	  -1,		/* 220	*/
	  -1,		/* 221	*/
	  -1,		/* 222	*/
	  -1,		/* 223	*/
	  -1,		/* 224	*/
	  -1,		/* 225	*/
	  -1,		/* 226	*/
	  -1,		/* 227	*/
	  -1,		/* 228	*/
	  -1,		/* 229	*/
	  -1,		/* 230	*/
	  -1,		/* 231	*/
	  -1,		/* 232	*/
	  -1,		/* 233	*/
	  -1,		/* 234	*/
	  -1,		/* 235	*/
	  -1,		/* 236	*/
	  -1,		/* 237	*/
	  -1,		/* 238	*/
	  -1,		/* 239	*/
	  -1,		/* 240	*/
	  -1,		/* 241	*/
	  -1,		/* 242	*/
	  -1,		/* 243	*/
	  -1,		/* 244	*/
	  -1,		/* 245	*/
	  -1,		/* 246	*/
	  -1,		/* 247	*/
	  -1,		/* 248	*/
	  -1,		/* 249	*/
	  -1,		/* 250	*/
	  -1,		/* 251	*/
	  -1,		/* 252	*/
	  -1,		/* 253	*/
	  -1,		/* 254	*/
	  -1,		/* 255	NRLAST_REGNUM */

	  __pr,		/* 256	PR0_REGNUM */
	  __p1,		/* 257	*/
	  __p2,		/* 258	*/
	  __p3,		/* 259	*/
	  __p4,		/* 260	*/
	  __p5,		/* 261	*/
	  __p6,		/* 262	*/
	  __p7,		/* 263	*/
	  __p8,		/* 264	*/
	  __p9,		/* 265	*/
	  __p10,	/* 266	*/
	  __p11,	/* 267	*/
	  __p12,	/* 268	*/
	  __p13,	/* 269	*/
	  __p14,	/* 270	*/
	  __p15,	/* 271	*/
	  __p16,	/* 272	*/
	  __p17,	/* 273	*/
	  __p18,	/* 274	*/
	  __p19,	/* 275	*/
	  __p20,	/* 276	*/
	  __p21,	/* 277	*/
	  __p22,	/* 278	*/
	  __p23,	/* 279	*/
	  __p24,	/* 280	*/
	  __p25,	/* 281	*/
	  __p26,	/* 282	*/
	  __p27,	/* 283	*/
	  __p28,	/* 284	*/
	  __p29,	/* 285	*/
	  __p30,	/* 286	*/
	  __p31,	/* 287	*/
	  __p32,	/* 288	*/
	  __p33,	/* 289	*/
	  __p34,	/* 290	*/
	  __p35,	/* 291	*/
	  __p36,	/* 292	*/
	  __p37,	/* 293	*/
	  __p38,	/* 294	*/
	  __p39,	/* 295	*/
	  __p40,	/* 296	*/
	  __p41,	/* 297	*/
	  __p42,	/* 298	*/
	  __p43,	/* 299	*/
	  __p44,	/* 300	*/
	  __p45,	/* 301	*/
	  __p46,	/* 302	*/
	  __p47,	/* 303	*/
	  __p48,	/* 304	*/
	  __p49,	/* 305	*/
	  __p50,	/* 306	*/
	  __p51,	/* 307	*/
	  __p52,	/* 308	*/
	  __p53,	/* 309	*/
	  __p54,	/* 310	*/
	  __p55,	/* 311	*/
	  __p56,	/* 312	*/
	  __p57,	/* 313	*/
	  __p58,	/* 314	*/
	  __p59,	/* 315	*/
	  __p60,	/* 316	*/
	  __p61,	/* 317	*/
	  __p62,	/* 318	*/
	  __p63,	/* 319	PRLAST_REGNUM */

	  -1,		/* 320 GR0_REGNUM */
	  __r1,		/* 321	*/
	  __r2,		/* 322	*/
	  __r3,		/* 323	*/
	  __r4,		/* 324	*/
	  __r5,		/* 325	*/
	  __r6,		/* 326	*/
	  __r7,		/* 327	*/
	  __r8,		/* 328	*/
	  __r9,		/* 329	*/
	  __r10,	/* 330	*/
	  __r11,	/* 331	*/
	  __r12,	/* 332	*/
	  __r13,	/* 333	*/
	  __r14,	/* 334	*/
	  __r15,	/* 335	*/
	  __r16,	/* 336	*/
	  __r17,	/* 337	*/
	  __r18,	/* 338	*/
	  __r19,	/* 339	*/
	  __r20,	/* 340	*/
	  __r21,	/* 341	*/
	  __r22,	/* 342	*/
	  __r23,	/* 343	*/
	  __r24,	/* 344	*/
	  __r25,	/* 345	*/
	  __r26,	/* 346	*/
	  __r27,	/* 347	*/
	  __r28,	/* 348	*/
	  __r29,	/* 349	*/
	  __r30,	/* 350	*/
	  __r31,	/* 351	*/
	  __r32,	/* 352	*/
	  __r33,	/* 353	*/
	  __r34,	/* 354	*/
	  __r35,	/* 355	*/
	  __r36,	/* 356	*/
	  __r37,	/* 357	*/
	  __r38,	/* 358	*/
	  __r39,	/* 359	*/
	  __r40,	/* 360	*/
	  __r41,	/* 361	*/
	  __r42,	/* 362	*/
	  __r43,	/* 363	*/
	  __r44,	/* 364	*/
	  __r45,	/* 365	*/
	  __r46,	/* 366	*/
	  __r47,	/* 367	*/
	  __r48,	/* 368	*/
	  __r49,	/* 369	*/
	  __r50,	/* 370	*/
	  __r51,	/* 371	*/
	  __r52,	/* 372	*/
	  __r53,	/* 373	*/
	  __r54,	/* 374	*/
	  __r55,	/* 375	*/
	  __r56,	/* 376	*/
	  __r57,	/* 377	*/
	  __r58,	/* 378	*/
	  __r59,	/* 379	*/
	  __r60,	/* 380	*/
	  __r61,	/* 381	*/
	  __r62,	/* 382	*/
	  __r63,	/* 383	*/
	  __r64,	/* 384	*/
	  __r65,	/* 385	*/
	  __r66,	/* 386	*/
	  __r67,	/* 387	*/
	  __r68,	/* 388	*/
	  __r69,	/* 389	*/
	  __r70,	/* 390	*/
	  __r71,	/* 391	*/
	  __r72,	/* 392	*/
	  __r73,	/* 393	*/
	  __r74,	/* 394	*/
	  __r75,	/* 395	*/
	  __r76,	/* 396	*/
	  __r77,	/* 397	*/
	  __r78,	/* 398	*/
	  __r79,	/* 399	*/
	  __r80,	/* 400	*/
	  __r81,	/* 401	*/
	  __r82,	/* 402	*/
	  __r83,	/* 403	*/
	  __r84,	/* 404	*/
	  __r85,	/* 405	*/
	  __r86,	/* 406	*/
	  __r87,	/* 407	*/
	  __r88,	/* 408	*/
	  __r89,	/* 409	*/
	  __r90,	/* 400	*/
	  __r91,	/* 411	*/
	  __r92,	/* 412	*/
	  __r93,	/* 413	*/
	  __r94,	/* 414	*/
	  __r95,	/* 415	*/
	  __r96,	/* 416	*/
	  __r97,	/* 417	*/
	  __r98,	/* 418	*/
	  __r99,	/* 419	*/
	  __r100,	/* 420	*/
	  __r101,	/* 421	*/
	  __r102,	/* 422	*/
	  __r103,	/* 423	*/
	  __r104,	/* 424	*/
	  __r105,	/* 425	*/
	  __r106,	/* 426	*/
	  __r107,	/* 427	*/
	  __r108,	/* 428	*/
	  __r109,	/* 429	*/
	  __r110,	/* 430	*/
	  __r111,	/* 431	*/
	  __r112,	/* 432	*/
	  __r113,	/* 433	*/
	  __r114,	/* 434	*/
	  __r115,	/* 435	*/
	  __r116,	/* 436	*/
	  __r117,	/* 437	*/
	  __r118,	/* 438	*/
	  __r119,	/* 439	*/
	  __r110,	/* 440	*/
	  __r121,	/* 441	*/
	  __r122,	/* 442	*/
	  __r123,	/* 443	*/
	  __r124,	/* 444	*/
	  __r125,	/* 445	*/
	  __r126,	/* 446	*/
	  __r127,	/* 447	GRLAST_REGNUM */

	  __b0,		/* 448	BR0_REGNUM */
	  __b1,		/* 449	*/
	  __b2,		/* 450	*/
	  __b3,		/* 451	*/
	  __b4,		/* 452	*/
	  __b5,		/* 453	*/
	  __b6,		/* 454	*/
	  __b7,		/* 455	BRLAST_REGNUM */

	  __ar0,	/* 456	AR0_REGNUM */
	  __ar1,	/* 457	*/
	  __ar2,	/* 458	*/
	  __ar3,	/* 459	*/
	  __ar4,	/* 460	*/
	  __ar5,	/* 461	*/
	  __ar6,	/* 462	*/
	  __ar7,	/* 463	*/
	  __ar8,	/* 464	*/
	  __ar9,	/* 465	*/
	  __ar10,	/* 466	*/
	  __ar11,	/* 467	*/
	  __ar12,	/* 468	*/
	  __ar13,	/* 469	*/
	  __ar14,	/* 470	*/
	  __ar15,	/* 471	*/
	  __ar16,	/* 472	*/
	  __ar17,	/* 473	*/
	  __ar18,	/* 474	*/
	  __ar19,	/* 475	*/
	  __ar20,	/* 476	*/
	  __ar21,	/* 477	*/
	  __ar22,	/* 478	*/
	  __ar23,	/* 479	*/
	  __ar24,	/* 480	*/
	  __ar25,	/* 481	*/
	  __ar26,	/* 482	*/
	  __ar27,	/* 483	*/
	  __ar28,	/* 484	*/
	  __ar29,	/* 485	*/
	  __ar30,	/* 486	*/
	  __ar31,	/* 487	*/
	  __ar32,	/* 488	*/
	  __ar33,	/* 489	*/
	  __ar34,	/* 490	*/
	  __ar35,	/* 491	*/
	  __ar36,	/* 492	*/
	  __ar37,	/* 493	*/
	  __ar38,	/* 494	*/
	  __ar39,	/* 495	*/
	  __ar40,	/* 496	*/
	  __ar41,	/* 497	*/
	  __ar42,	/* 498	*/
	  __ar43,	/* 499	*/
	  __ar44,	/* 500	*/
	  __ar45,	/* 501	*/
	  __ar46,	/* 502	*/
	  __ar47,	/* 503	*/
	  __ar48,	/* 504	*/
	  __ar49,	/* 505	*/
	  __ar50,	/* 506	*/
	  __ar51,	/* 507	*/
	  __ar52,	/* 508	*/
	  __ar53,	/* 509	*/
	  __ar54,	/* 510	*/
	  __ar55,	/* 511	*/
	  __ar56,	/* 512	*/
	  __ar57,	/* 513	*/
	  __ar58,	/* 514	*/
	  __ar59,	/* 515	*/
	  __ar60,	/* 516	*/
	  __ar61,	/* 517	*/
	  __ar62,	/* 518	*/
	  __ar63,	/* 519	*/
	  __ar64,	/* 520	*/
	  __ar65,	/* 521	*/
	  __ar66,	/* 522	*/
	  __ar67,	/* 523	*/
	  __ar68,	/* 524	*/
	  __ar69,	/* 525	*/
	  __ar70,	/* 526	*/
	  __ar71,	/* 527	*/
	  __ar72,	/* 528	*/
	  __ar73,	/* 529	*/
	  __ar74,	/* 530	*/
	  __ar75,	/* 531	*/
	  __ar76,	/* 532	*/
	  __ar77,	/* 533	*/
	  __ar78,	/* 534	*/
	  __ar79,	/* 535	*/
	  __ar80,	/* 536	*/
	  __ar81,	/* 537	*/
	  __ar82,	/* 538	*/
	  __ar83,	/* 539	*/
	  __ar84,	/* 540	*/
	  __ar85,	/* 541	*/
	  __ar86,	/* 542	*/
	  __ar87,	/* 543	*/
	  __ar88,	/* 544	*/
	  __ar89,	/* 545	*/
	  __ar90,	/* 546	*/
	  __ar91,	/* 547	*/
	  __ar92,	/* 548	*/
	  __ar93,	/* 549	*/
	  __ar94,	/* 550	*/
	  __ar95,	/* 551	*/
	  __ar96,	/* 552	*/
	  __ar97,	/* 553	*/
	  __ar98,	/* 554	*/
	  __ar99,	/* 555	*/
	  __ar100,	/* 556	*/
	  __ar101,	/* 557	*/
	  __ar102,	/* 558	*/
	  __ar103,	/* 559	*/
	  __ar104,	/* 560	*/
	  __ar105,	/* 561	*/
	  __ar106,	/* 562	*/
	  __ar107,	/* 563	*/
	  __ar108,	/* 564	*/
	  __ar109,	/* 565	*/
	  __ar110,	/* 566	*/
	  __ar111,	/* 567	*/
	  __ar112,	/* 568	*/
	  __ar113,	/* 569	*/
	  __ar114,	/* 570	*/
	  __ar115,	/* 571	*/
	  __ar116,	/* 572	*/
	  __ar117,	/* 573	*/
	  __ar118,	/* 574	*/
	  __ar119,	/* 575	*/
	  __ar120,	/* 576	*/
	  __ar121,	/* 577	*/
	  __ar122,	/* 578	*/
	  __ar123,	/* 579	*/
	  __ar124,	/* 580	*/
	  __ar125,	/* 581	*/
	  __ar126,	/* 582	*/
	  __ar127,	/* 583	ARLAST_REGNUM */

	  __ip,		/* 584	PC_REGNUM */
	  __cfm,	/* 585	CFM_REGNUM the low 38 bits of __cr_isr 
				__cfm is a pseudo-register from ttrace.
			 */

	  __cr_ipsr,	/* 586	PSR_REGNUM */
	  __reason,	/* 587	REASON_REGNUM */
	};
/* NOTE: If you add any new registers to the end of this list, remember to
   change NUM_REGS and PR_REGNUM (should be last register not listed here). */

